class JWP_Scoreboard extends StaticMeshActor ClassGroup( Pinball );

/* An array of references to the character objects held within this scoreboard. */
var JWP_ScoreboardPanel Characters[ 28 ];

/* Configures the scoreboard's characters to display the intro graphic.       */
/*----------------------------------------------------------------------------*/
function DrawIntro()
{

    local int Character;

    /* Write the checker pattern at 1,4 to the outermost four columns on both rows. */
    for( Character = 0; Character < 2; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 12; Character < 14; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 14; Character < 16; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 26; Character < 28; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );

    /* Write JAMES, a space, and WILD to the top row. */
    for( Character = 0; Character < 5; Character++ ) Characters[ 16 + Character ].SetCharacter( 3 + Character, 4 );
    Characters[ 21 ].SetCharacter( 4, 3 );
    for( Character = 0; Character < 4; Character++ ) Characters[ 22 + Character ].SetCharacter( 5 + Character, 5 );

    /* Write out 2011 to the centre below. */
    Characters[ 5 ].SetCharacter( 2, 0 );
    Characters[ 6 ].SetCharacter( 0, 0 );
    Characters[ 7 ].SetCharacter( 1, 0 );
    Characters[ 8 ].SetCharacter( 1, 0 );

    /* Pad the year with spaces. */
    for( Character = 2; Character < 5; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );
    for( Character = 9; Character < 12; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );

}

/* Sets the scoreboard characters to display the title graphic.               */
/*----------------------------------------------------------------------------*/
function DrawTitle()
{

    local int Character;

    /* Write the checker pattern at 1,4 to the outermost four columns on both rows. */
    for( Character = 0; Character < 2; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 12; Character < 14; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 14; Character < 16; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 26; Character < 28; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );

    /* Copy the two rows of the title image in the space between. */
    for( Character = 0; Character < 10; Character++ )
    {

        Characters[ 16 + Character ].SetCharacter( Character, 6 );
        Characters[ 2 + Character ].SetCharacter( Character, 7 );

    }

}

/* Renders the amount of points needed for an extra ball to the scoreboard.   */
/*----------------------------------------------------------------------------*/
function DrawExtraBalls( int Points )
{

    local int Character;

    /* Fill the outer tiles of the up row with spaces. */
    Characters[ 14 ].SetCharacter( 4, 3 );
    for( Character = 26; Character < 28; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );

    /* Copy the word EXTRA to the left of the top row. */
    for( Character = 0; Character < 5; Character++ ) Characters[ Character + 15 ].SetCharacter( Character, 2 );

    /* Copy the word BALL to the right. */
    for( Character = 0; Character < 5; Character++ ) Characters[ Character + 21 ].SetCharacter( Character + 5, 2 );
    Characters[ 26 ].SetCharacter( 8, 4 );

    /* Fill the tile between the two words with a space. */
    Characters[ 20 ].SetCharacter( 4, 3 );

    DrawPointsAlt( Points );

}

/* Overwrites the points display with a notification of an extra ball award.  */
/*----------------------------------------------------------------------------*/
function DrawExtraBall( int Balls )
{

    local int Character;

    /* Write EXTRA and BALL. */
    for( Character = 0; Character < 5; Character++ ) Characters[ Character + 16 ].SetCharacter( Character, 2 );
    for( Character = 0; Character < 4; Character++ ) Characters[ Character + 22 ].SetCharacter( Character + 5, 2 );

    /* Fill the outer tiles of the up row with spaces. */
    for( Character = 14; Character < 16; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );
    for( Character = 26; Character < 28; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );

    /* Exclaimation mark and space. */
    Characters[ 21 ].SetCharacter( 9, 3 );
    Characters[ 21 ].SetCharacter( 4, 3 );

    DrawBalls( Balls );

}

/* Replaces the display of points with a notification of multiball mode.      */
/*----------------------------------------------------------------------------*/
function DrawMultiBall( int Balls )
{

    local int Character;

    /* Write MULTI and BALL. */
    for( Character = 0; Character < 5; Character++ ) Characters[ Character + 15 ].SetCharacter( Character, 5 );
    for( Character = 0; Character < 4; Character++ ) Characters[ Character + 22 ].SetCharacter( Character + 5, 2 );

    /* Fill the outer tiles of the up row with spaces. */
    for( Character = 14; Character < 16; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );
    for( Character = 26; Character < 28; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );

    /* Exclaimation mark and space. */
    Characters[ 21 ].SetCharacter( 9, 3 );
    Characters[ 25 ].SetCharacter( 4, 3 );

    DrawBalls( Balls );

}

/* Draws the are you sure menu used for quitting or restarting.               */
/*----------------------------------------------------------------------------*/
function DrawAreYouSure( bool Option )
{

    local int Character;

    /* Write ARE YOU SURE? */
    for( Character = 0; Character < 7; Character++ ) Characters[ Character + 15 ].SetCharacter( Character, 15 );
    for( Character = 0; Character < 6; Character++ ) Characters[ Character + 22 ].SetCharacter( Character + 3, 14 );
    Characters[ 14 ].SetCharacter( 4, 3 );
    Characters[ 27 ].SetCharacter( 4, 3 );

    /* Draw flippers. */
    Characters[ 0 ].SetCharacter( 0, 12 );
    Characters[ 1 ].SetCharacter( 1, 12 );
    Characters[ 2 ].SetCharacter( 2, 12 );
    for( Character = 3; Character < 11; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );
    Characters[ 11 ].SetCharacter( 3, 12 );
    Characters[ 12 ].SetCharacter( 4, 12 );
    Characters[ 13 ].SetCharacter( 5, 12 );

    /* Draw YES or NO. */
    if( Option )
    {

        Characters[ 6 ].SetCharacter( 8, 8 );
        Characters[ 7 ].SetCharacter( 8, 9 );
        Characters[ 8 ].SetCharacter( 8, 10 );

    }
    else
    {

        Characters[ 7 ].SetCharacter( 9, 8 );
        Characters[ 8 ].SetCharacter( 9, 9 );

    }

}

/* Draws the pause menu.                                                      */
/*----------------------------------------------------------------------------*/
function DrawPause( int Option )
{

    local int Character;

    /* Write PAUSED */
    for( Character = 0; Character < 7; Character++ ) Characters[ Character + 18 ].SetCharacter( Character, 8 );
    for( Character = 14; Character < 18; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );
    for( Character = 25; Character < 28; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );

    /* Draw flippers. */
    Characters[ 0 ].SetCharacter( 0, 12 );
    Characters[ 1 ].SetCharacter( 1, 12 );
    Characters[ 2 ].SetCharacter( 2, 12 );
    for( Character = 3; Character < 11; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );
    Characters[ 11 ].SetCharacter( 3, 12 );
    Characters[ 12 ].SetCharacter( 4, 12 );
    Characters[ 13 ].SetCharacter( 5, 12 );

    /* Write the current state. */
    for( Character = 0; Character < 7; Character++ ) Characters[ Character + 4 ].SetCharacter( Character, 9 + Option );

}

/* Renders the points bonus notification to the top line.                     */
/*----------------------------------------------------------------------------*/
function DrawBonus( int Points )
{

    local int Character;

    Characters[ 14 ].SetCharacter( 4, 3 );

    /* Write BONUS */
    for( Character = 0; Character < 5; Character++ ) Characters[ Character + 15 ].SetCharacter( 7, Character + 8 );

    Characters[ 20 ].SetCharacter( 4, 3 );

    /* Write POINTS */
    for( Character = 0; Character < 6; Character++ ) Characters[ Character + 21 ].SetCharacter( Character, 1 );

    Characters[ 27 ].SetCharacter( 9, 3 );

    DrawPointsAlt( Points );

}

/* Puts HIGHSCORE: on the top line.                                           */
/*----------------------------------------------------------------------------*/
function DrawHighscore( int Points )
{

    local int Character;

    Characters[ 14 ].SetCharacter( 4, 3 );
    Characters[ 15 ].SetCharacter( 4, 3 );

    /* Write HIGHSCORE: */
    for( Character = 0; Character < 10; Character++ ) Characters[ Character + 16 ].SetCharacter( Character, 13 );

    Characters[ 26 ].SetCharacter( 4, 3 );
    Characters[ 27 ].SetCharacter( 4, 3 );

    DrawPointsAlt( Points );

}

/* Puts NEW HIGHSCORE! on the top line.                                       */
/*----------------------------------------------------------------------------*/
function DrawNewHighscore( int Points )
{

    local int Character;

    /* Write NEW */
    for( Character = 0; Character < 4; Character++ ) Characters[ Character + 14 ].SetCharacter( Character, 14 );

    /* Write HIGHSCORE */
    for( Character = 0; Character < 9; Character++ ) Characters[ Character + 18 ].SetCharacter( Character, 13 );

    Characters[ 27 ].SetCharacter( 9, 3 );

    DrawPointsAlt( Points );

}

/* Show the GAME OVER graphic on the scoreboard.                              */
/*----------------------------------------------------------------------------*/
function DrawGameOver()
{

    local int Character;

    /* Write the checker pattern at 1,4 to the outermost four columns on both rows. */
    for( Character = 0; Character < 2; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 12; Character < 14; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 14; Character < 16; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );
    for( Character = 26; Character < 28; Character++ ) Characters[ Character ].SetCharacter( 1, 4 );

    /* Write GAME, OVER and the speed trails. */
    for( Character = 0; Character < 4; Character++ ) Characters[ 17 + Character ].SetCharacter( Character, 3 );
    for( Character = 0; Character < 4; Character++ ) Characters[ 21 + Character ].SetCharacter( Character + 6, 1 );
    for( Character = 0; Character < 5; Character++ ) Characters[ 7 + Character ].SetCharacter( Character + 5, 3 );
    for( Character = 0; Character < 4; Character++ ) Characters[ 3 + Character ].SetCharacter( ( 4 - Character ) + 5, 1 );

    /* Pad with spaces. */
    Characters[ 2 ].SetCharacter( 4, 3 );
    Characters[ 16 ].SetCharacter( 4, 3 );
    Characters[ 25 ].SetCharacter( 4, 3 );

}

/* Configures the ball display row to show the current amount of balls the    */
/* player has using a pictogram or text depending upon which is most suitable.*/
/*----------------------------------------------------------------------------*/
function DrawBalls( int Balls )
{

    local int Character;
    local string Ballstring;
    local int Balllength;

    /* If there are no balls, draw a zero. */
    if( Balls == 0 )
    {

        /* Write a zero and fill the rest with empty space. */
        for( Character = 0; Character < 7; Character++ ) Characters[ Character ].SetCharacter( 4, 3 );
        Characters[ 7 ].SetCharacter( 0, 0 );

    }
    else
    {

        /* If we have the right number to display using a pictogram, do it. */
        if( Balls < 9 )
        {

            /* Fill with the appropiate number of ball sprites. */
            for( Character = 0; Character < Balls; Character++ ) Characters[ 7 - Character ].SetCharacter( 0, 4 );

            /* Fill the remainder with spaces. */
            while( Character < 8 ) { Characters[ 7 - Character ].SetCharacter( 4, 3 ); Character++; }

        }
        else
        /* Otherwise, use text to display the value. */
        {

            /* Convert the amount of balls to a text string. */
            Ballstring = string( Balls );
            Balllength = Len( Ballstring );

            /* Run backwards through the string until we run out of characters. */
            for( Character = 0; Character < Balllength; Character++ ) Characters[ 7 - Character ].SetCharacter( asc( Right( Ballstring, Character + 1 ) ) - 48, 0 );

            /* Fill the remainder with spaces. */
            while( Character < 8 ) { Characters[ 7 - Character ].SetCharacter( 4, 3 ); Character++; }

        }

    }

    /* Write the word BALLS. */
    for( Character = 0; Character < 5; Character++ ) Characters[ Character + 9 ].SetCharacter( Character + 5, 2 );
    /* Add a space between the number and the word BALLS. */
    Characters[ 8 ].SetCharacter( 4, 3 );

}

/* Draws the points value onto the wrong row. (sometimes makes sense)         */
/*----------------------------------------------------------------------------*/
function DrawPointsAlt( int Points )
{

    local int Character;
    local string Pointstring;
    local int Pointslength;

    /* Convert the points value to a text string. */
    Pointstring = string( Points );
    Pointslength = Len( Pointstring );

    /* Run backwards through the string until we run out of characters. */
    for( Character = 0; Character < Pointslength; Character++ ) Characters[ 6 - Character ].SetCharacter( asc( Right( Pointstring, Character + 1 ) ) - 48, 0 );

    /* Fill the remainder with spaces. */
    while( Character < 7 ) { Characters[ 6 - Character ].SetCharacter( 4, 3 ); Character++; }

    /* Add the word POINTS. */
    for( Character = 0; Character < 6; Character++ ) Characters[ Character + 8 ].SetCharacter( Character, 1 );
    /* Add a space between the number and the word POINTS. */
    Characters[ 7 ].SetCharacter( 4, 3 );

}

/* Updates the points row with the latest value.                              */
/*----------------------------------------------------------------------------*/
function DrawPoints( int Points )
{

    local int Character;
    local string Pointstring;
    local int Pointslength;

    /* Convert the points value to a text string. */
    Pointstring = string( Points );
    Pointslength = Len( Pointstring );

    /* Run backwards through the string until we run out of characters. */
    for( Character = 0; Character < Pointslength; Character++ ) Characters[ 20 - Character ].SetCharacter( asc( Right( Pointstring, Character + 1 ) ) - 48, 0 );

    /* Fill the remainder with spaces. */
    while( Character < 7 ) { Characters[ 20 - Character ].SetCharacter( 4, 3 ); Character++; }

    /* Add the word POINTS. */
    for( Character = 0; Character < 6; Character++ ) Characters[ Character + 22 ].SetCharacter( Character, 1 );
    /* Add a space between the number and the word POINTS. */
    Characters[ 21 ].SetCharacter( 4, 3 );

}

/* Called before the first frame of gameplay.                                 */
/*----------------------------------------------------------------------------*/
event PreBeginPlay()
{

    local int Character;

    /* It's unlikely an Actor derivative would have anything to do before gameplay, but it's worth performing any necessary tasks regardless. */
    Super.PreBeginPlay();

    /* Tell each tile to prepare for action, generating their material instances. */
    for( Character = 0; Character < 28; Character++ ) Characters[ Character ].SetupCharacter();

}

/* Preprocessor macro to add a scoreboard tile with the specified ID with the */
/* specified X/Y offset.  In an ideal world, the X/Y could be calculated but  */
/* Unreal's preprocessor doesn't seem powerful enough to do that easily.      */
/*----------------------------------------------------------------------------*/
`define AddPanel( id, x, y ) \
\
    Begin Object Class=JWP_ScoreboardPanel Name=Panel`id \n\
    \
        Translation = ( X = `x, Y = 0.0f, Z = `y ); \n\
    \
    End Object \n\
    \
    Characters[ `id ] = Panel`id; \n\
    \
    Components.Add( Panel`id );
/*----------------------------------------------------------------------------*/

defaultproperties
{

    /* Put a box around the display.                                              */
    /*----------------------------------------------------------------------------*/
    Begin Object Name=StaticMeshComponent0

        StaticMesh = StaticMesh'JWPContent.DisplayBox';

    End Object

    /* Using the above preprocessor macro, add each tile as a component.          */
    /*----------------------------------------------------------------------------*/
    `AddPanel( 0, 0, 0 )
    `AddPanel( 1, 48, 0 )
    `AddPanel( 2, 96, 0 )
    `AddPanel( 3, 144, 0 )
    `AddPanel( 4, 192, 0 )
    `AddPanel( 5, 240, 0 )
    `AddPanel( 6, 288, 0 )
    `AddPanel( 7, 336, 0 )
    `AddPanel( 8, 384, 0 )
    `AddPanel( 9, 432, 0 )
    `AddPanel( 10, 480, 0 )
    `AddPanel( 11, 528, 0 )
    `AddPanel( 12, 576, 0 )
    `AddPanel( 13, 624, 0 )

    `AddPanel( 14, 0, 64 )
    `AddPanel( 15, 48, 64 )
    `AddPanel( 16, 96, 64 )
    `AddPanel( 17, 144, 64 )
    `AddPanel( 18, 192, 64 )
    `AddPanel( 19, 240, 64 )
    `AddPanel( 20, 288, 64 )
    `AddPanel( 21, 336, 64 )
    `AddPanel( 22, 384, 64 )
    `AddPanel( 23, 432, 64 )
    `AddPanel( 24, 480, 64 )
    `AddPanel( 25, 528, 64 )
    `AddPanel( 26, 576, 64 )
    `AddPanel( 27, 624, 64 )
    /*----------------------------------------------------------------------------*/

    /* We want events to fire as if the object were a dynamic. */
    bStatic = false;

}
