class JWP_ScoreboardPanel extends StaticMeshComponent Notplaceable;

/* A reference to a material instance used to control our individual character. */
var MaterialInstanceConstant Parameters;

/* Sets our character to the requested atlas location given by our parent scoreboard. */
function SetCharacter( int X, int Y )
{

    Parameters.SetScalarParameterValue('AtlasX', X );
    Parameters.SetScalarParameterValue('AtlasY', Y );

}

/* When instructed by the parent scoreboard, generates and configures a material instance. */
function SetupCharacter()
{

    Parameters = new( self ) Class'MaterialInstanceConstant';
    Parameters.SetParent( GetMaterial( 0 ) );
    SetMaterial( 0, Parameters );

}

defaultproperties
{

    /* The display tile is to be used, and lit. */
    StaticMesh = StaticMesh'JWPContent.Display';

    bAllowApproximateOcclusion = true;
    bForceDirectLightMap = true;
    bUsePrecomputedShadows = true;

}
